# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AnalyticsAdmin.V1alpha.Connection do
  @moduledoc """
  Handle Tesla connections for GoogleApi.AnalyticsAdmin.V1alpha.
  """

  @type t :: Tesla.Env.client()

  use GoogleApi.Gax.Connection,
    scopes: [
      # Edit Google Analytics management entities
      "https://www.googleapis.com/auth/analytics.edit",

      # Manage Google Analytics Account users by email address
      "https://www.googleapis.com/auth/analytics.manage.users",

      # View Google Analytics user permissions
      "https://www.googleapis.com/auth/analytics.manage.users.readonly",

      # See and download your Google Analytics data
      "https://www.googleapis.com/auth/analytics.readonly"
    ],
    otp_app: :google_api_analytics_admin,
    base_url: "https://analyticsadmin.googleapis.com/"
end
