# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChange do
  @moduledoc """
  A description of a change to a single Google Analytics resource.

  ## Attributes

  *   `action` (*type:* `String.t`, *default:* `nil`) - The type of action that changed this resource.
  *   `resource` (*type:* `String.t`, *default:* `nil`) - Resource name of the resource whose changes are described by this entry.
  *   `resourceAfterChange` (*type:* `GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChangeChangeHistoryResource.t`, *default:* `nil`) - Resource contents from after the change was made. If this resource was deleted in this change, this field will be missing.
  *   `resourceBeforeChange` (*type:* `GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChangeChangeHistoryResource.t`, *default:* `nil`) - Resource contents from before the change was made. If this resource was created in this change, this field will be missing.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :action => String.t() | nil,
          :resource => String.t() | nil,
          :resourceAfterChange =>
            GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChangeChangeHistoryResource.t()
            | nil,
          :resourceBeforeChange =>
            GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChangeChangeHistoryResource.t()
            | nil
        }

  field(:action)
  field(:resource)

  field(:resourceAfterChange,
    as:
      GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChangeChangeHistoryResource
  )

  field(:resourceBeforeChange,
    as:
      GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChangeChangeHistoryResource
  )
end

defimpl Poison.Decoder,
  for: GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChange do
  def decode(value, options) do
    GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChange.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaChangeHistoryChange do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
