# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStream do
  @moduledoc """
  A resource message representing a data stream.

  ## Attributes

  *   `androidAppStreamData` (*type:* `GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamAndroidAppStreamData.t`, *default:* `nil`) - Data specific to Android app streams. Must be populated if type is ANDROID_APP_DATA_STREAM.
  *   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Time when this stream was originally created.
  *   `displayName` (*type:* `String.t`, *default:* `nil`) - Human-readable display name for the Data Stream. Required for web data streams. The max allowed display name length is 255 UTF-16 code units.
  *   `iosAppStreamData` (*type:* `GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamIosAppStreamData.t`, *default:* `nil`) - Data specific to iOS app streams. Must be populated if type is IOS_APP_DATA_STREAM.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Output only. Resource name of this Data Stream. Format: properties/{property_id}/dataStreams/{stream_id} Example: "properties/1000/dataStreams/2000"
  *   `type` (*type:* `String.t`, *default:* `nil`) - Required. Immutable. The type of this DataStream resource.
  *   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Time when stream payload fields were last updated.
  *   `webStreamData` (*type:* `GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamWebStreamData.t`, *default:* `nil`) - Data specific to web streams. Must be populated if type is WEB_DATA_STREAM.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :androidAppStreamData =>
            GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamAndroidAppStreamData.t()
            | nil,
          :createTime => DateTime.t() | nil,
          :displayName => String.t() | nil,
          :iosAppStreamData =>
            GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamIosAppStreamData.t()
            | nil,
          :name => String.t() | nil,
          :type => String.t() | nil,
          :updateTime => DateTime.t() | nil,
          :webStreamData =>
            GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamWebStreamData.t()
            | nil
        }

  field(:androidAppStreamData,
    as:
      GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamAndroidAppStreamData
  )

  field(:createTime, as: DateTime)
  field(:displayName)

  field(:iosAppStreamData,
    as: GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamIosAppStreamData
  )

  field(:name)
  field(:type)
  field(:updateTime, as: DateTime)

  field(:webStreamData,
    as: GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamWebStreamData
  )
end

defimpl Poison.Decoder,
  for: GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStream do
  def decode(value, options) do
    GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStream.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStream do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
