# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamAndroidAppStreamData do
  @moduledoc """
  Data specific to Android app streams.

  ## Attributes

  *   `firebaseAppId` (*type:* `String.t`, *default:* `nil`) - Output only. ID of the corresponding Android app in Firebase, if any. This ID can change if the Android app is deleted and recreated.
  *   `packageName` (*type:* `String.t`, *default:* `nil`) - Immutable. The package name for the app being measured. Example: "com.example.myandroidapp"
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :firebaseAppId => String.t() | nil,
          :packageName => String.t() | nil
        }

  field(:firebaseAppId)
  field(:packageName)
end

defimpl Poison.Decoder,
  for:
    GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamAndroidAppStreamData do
  def decode(value, options) do
    GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamAndroidAppStreamData.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for:
    GoogleApi.AnalyticsAdmin.V1beta.Model.GoogleAnalyticsAdminV1betaDataStreamAndroidAppStreamData do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
